package klassen;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

/**
  *
  * Beschreibung
  *
  * @version 1.0 vom 26.11.2015
  * @author 
  */

public class Hauptfenster extends JFrame {
  /**
	 * 
	 */
	private static final long serialVersionUID = -3449789944169784606L;
// Anfang Attribute
  private JLabel lbTitel = new JLabel();
  private JLabel lbVorwaerts = new JLabel();
  private JTextField tfWort = new JTextField();
  private JButton btWort_umdrehen = new JButton();
  
  private Wort dasWort = new Wort();
  private JLabel lbErgebnis = new JLabel();
  private JButton btTeilwort = new JButton();
  private JButton btUmlaute = new JButton();
  private JButton btSortieren = new JButton();
  private JButton btSaubermachen = new JButton();
  private final JLabel lblcon = new JLabel("");
  // Ende Attribute
  
  public Hauptfenster(String title) { 
    // Frame-Initialisierung
    super(title);
    setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
    int frameWidth = 304; 
    int frameHeight = 507;
    setSize(frameWidth, frameHeight);
    Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
    int x = (d.width - getSize().width) / 2;
    int y = (d.height - getSize().height) / 2;
    setLocation(x, y);
    setResizable(false);
    Container cp = getContentPane();
    cp.setLayout(null);
    // Anfang Komponenten
    
    
    lbTitel.setBounds(16, 8, 168, 41);
    lbTitel.setText("Wortspiele");
    lbTitel.setFont(new Font("Dialog", Font.BOLD, 18));
    cp.add(lbTitel);
    lbVorwaerts.setBounds(16, 56, 147, 25);
    lbVorwaerts.setText("Eingabe Wort:");
    cp.add(lbVorwaerts);
    tfWort.setBounds(24, 96, 185, 41);
    tfWort.setText("tfWort");
    tfWort.setBackground(new Color(0xC0C0C0));
    cp.add(tfWort);
    btWort_umdrehen.setBounds(24, 152, 233, 33);
    btWort_umdrehen.setText("Wort umdrehen");
    btWort_umdrehen.setMargin(new Insets(2, 2, 2, 2));
    btWort_umdrehen.addActionListener(new ActionListener() { 
      public void actionPerformed(ActionEvent evt) { 
        btWort_umdrehen_ActionPerformed(evt);
      }
    });
    cp.add(btWort_umdrehen);
    cp.setBackground(Color.WHITE);
    
    lbErgebnis.setBounds(24, 384, 235, 25);
    lbErgebnis.setText("lbErgebnis");
    lbErgebnis.setFont(new Font("Dialog", Font.BOLD + Font.ITALIC, 15));
    lbErgebnis.setForeground(Color.RED);
    lbErgebnis.setBackground(new Color(0xC0C0C0));
    lbErgebnis.setOpaque(true);
    cp.add(lbErgebnis);
    btTeilwort.setBounds(24, 200, 233, 33);
    btTeilwort.setText("Teilwort ausgeben");
    btTeilwort.setMargin(new Insets(2, 2, 2, 2));
    btTeilwort.addActionListener(new ActionListener() { 
      public void actionPerformed(ActionEvent evt) { 
        btTeilwort_ActionPerformed(evt);
      }
    });
    cp.add(btTeilwort);
    btUmlaute.setBounds(24, 248, 233, 33);
    btUmlaute.setText("Umlaute ersetzen");
    btUmlaute.setMargin(new Insets(2, 2, 2, 2));
    btUmlaute.addActionListener(new ActionListener() { 
      public void actionPerformed(ActionEvent evt) { 
        btUmlaute_ActionPerformed(evt);
      }
    });
    cp.add(btUmlaute);
    btSortieren.setBounds(24, 296, 233, 33);
    btSortieren.setText("Buchstaben sortieren");
    btSortieren.setMargin(new Insets(2, 2, 2, 2));
    btSortieren.addActionListener(new ActionListener() { 
      public void actionPerformed(ActionEvent evt) { 
        btSortieren_ActionPerformed(evt);
      }
    });
    cp.add(btSortieren);
    btSaubermachen.setBounds(24, 336, 233, 33);
    btSaubermachen.setText("Zeichenkette subern");
    btSaubermachen.setMargin(new Insets(2, 2, 2, 2));
    btSaubermachen.addActionListener(new ActionListener() { 
      public void actionPerformed(ActionEvent evt) { 
        btSaubermachen_ActionPerformed(evt);
      }
    });
    cp.add(btSaubermachen);
    lblcon.setIcon(new ImageIcon(Hauptfenster.class.getResource("/klassen/images/logo_final.png")));
    lblcon.setBounds(113, 417, 175, 50);
    
    getContentPane().add(lblcon);
    // Ende Komponenten
    
    setVisible(true);
  } // end of public Hauptfenster
  
  // Anfang Methoden
  
  public static void main(String[] args) {
    new Hauptfenster("Wortspiele");
  } // end of main
  
  /*Ereignissteuerung Umdrehen*/
  public void btWort_umdrehen_ActionPerformed(ActionEvent evt) {
    //Eingabe
    String mVorwaerts = tfWort.getText();
    
    //Verarbeitung
    dasWort.setVorwaerts(mVorwaerts);
    dasWort.umdrehen();
    
    //Ausgabe
    lbErgebnis.setText(dasWort.getRueckwaerts());
    
  } // end of btWort_umdrehen_ActionPerformed
  
  /*Ereignissteuerung Teilwort ermitteln*/
  public void btTeilwort_ActionPerformed(ActionEvent evt) {
    //Eingabe
    String mWort = tfWort.getText();
    
    //Verarbeitung
    dasWort.setVorwaerts(mWort);
    dasWort.teil_ermitteln();
    
    //Ausgabe
    lbErgebnis.setText(dasWort.getWortteil());
  } // end of btTeilwort_ActionPerformed
  
  /*Ereignissteuerung Umlaute ndern*/
  public void btUmlaute_ActionPerformed(ActionEvent evt) {
    //Eingabe
    String mWort = tfWort.getText();
    
    //Verarbeitung
    dasWort.setVorwaerts(mWort);
    dasWort.umlaute_ersetzen();
    
    //Ausgabe
    lbErgebnis.setText(dasWort.getUmlautlos());
    
  } // end of btUmlaute_ActionPerformed
  
  /*Ereignissteuerung Buchstaben Sortieren*/
  public void btSortieren_ActionPerformed(ActionEvent evt) {
    //Eingabe
    String mWort = tfWort.getText();                               
    
    //Verarbeitung
    dasWort.setVorwaerts(mWort);
    dasWort.bubblesort();
    
    //Ausgabe
    lbErgebnis.setText(dasWort.getSortiert());
    
  } // end of btSortieren_ActionPerformed
  
  /*Ereignissteuerung Zeichenkette subern*/
  public void btSaubermachen_ActionPerformed(ActionEvent evt) {
    //Eingabe
    String mWort = tfWort.getText();   
    
    //Verarbeitung
    dasWort.setVorwaerts(mWort);
    dasWort.saubermachen();
    
    //Ausgabe
    lbErgebnis.setText(dasWort.getSauber());
  } // end of btSaubermachen_ActionPerformed
} // end of class Hauptfenster
